//
//  ViewController.m
//  Wolt Intw
//
//  Created by Lukáš Fečke on 02/02/2017.
//  Copyright © 2017 Lukáš Fečke. All rights reserved.
//

#import "ViewController.h"

@interface ViewController ()

@property(nonatomic,strong) NSMutableArray *map;
@property(nonatomic,weak) IBOutlet UITextView *mapView;
@property(nonatomic,weak) IBOutlet UITextView *routeView;

@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    self.delegate = [[WIRouteFinder alloc] init];
    
//    self.map = [[NSMutableArray alloc] initWithObjects:
//  @[@"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#"],
//  @[@"@", @".", @"#", @".", @".", @".", @".", @".", @".", @"#"],
//  @[@"#", @".", @".", @".", @"#", @"#", @".", @".", @".", @"#"],
//  @[@"#", @".", @".", @".", @"#", @"#", @".", @"#", @".", @"#"],
//  @[@"#", @"#", @".", @".", @"#", @"#", @".", @".", @".", @"#"],
//  @[@"#", @"#", @".", @"#", @"#", @"#", @".", @"#", @"#", @"#"],
//  @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
//  @[@"#", @".", @".", @".", @".", @"#", @"#", @"#", @"#", @"#"],
//  @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"C"],
//  @[@"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#"], nil];
    
    self.map = [[NSMutableArray alloc] initWithObjects:
                @[@"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#"],
                @[@"@", @".", @"#", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @"#", @"#", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @"#", @"#", @".", @"#", @".", @"#"],
                @[@"#", @"#", @".", @".", @"#", @"#", @".", @".", @".", @"#"],
                @[@"#", @"#", @"#", @"#", @"#", @"#", @".", @"#", @"#", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @"#", @"#", @"#", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @"#", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @"#", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @"#", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @"#", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @"#", @".", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @"#", @"#"],
                @[@"#", @".", @".", @".", @".", @".", @".", @".", @".", @"C"],
                @[@"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#", @"#"], nil];
    
    [self.mapView setText:[self.delegate printMap:self.map]];
    
    UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(dismissKeyboardForAllTextFieldsInView)];
    
    [self.view addGestureRecognizer:tap];
}

- (IBAction)findRoute:(id)sender
{
    [self.routeView setText:[self.delegate getRouteFromTextViewMap:self.mapView]];
//    [self.routeView setText:[self.delegate findRoute:self.map]];
    [self.routeView setText:[NSString stringWithFormat:@"%@\n\n%@", [self.routeView text], [self.delegate printRoute]]];
}

-(void)dismissKeyboardForAllTextFieldsInView
{
    for (UITextField *textField in [self.view subviews])
    {
        [textField resignFirstResponder];
    }
}

- (void)didReceiveMemoryWarning
{
    NSLog(@"Memory fail due to RC: %d", [self.delegate getRC]);
}

@end
